<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: FATFS_VFS Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classFATFS__VFS-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">FATFS_VFS Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Provide access to the FAT file system on SPI flash. The <a class="el" href="classFATFS__VFS.html" title="Provide access to the FAT file system on SPI flash. The FATFS_VFS file system needs a partition defin...">FATFS_VFS</a> file system needs a partition definition. This is a map of flash memory that specified an array into which the files should be saved and loaded. A partition is a named entity and the name we choose in the partition definition should be named in the constructor.  
 <a href="classFATFS__VFS.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="FATFS__VFS_8h_source.html">FATFS_VFS.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad0794710c612340082e700903ffd1e1b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFATFS__VFS.html#ad0794710c612340082e700903ffd1e1b">FATFS_VFS</a> (std::string mountPath, std::string partitionName)</td></tr>
<tr class="memdesc:ad0794710c612340082e700903ffd1e1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ad0794710c612340082e700903ffd1e1b">More...</a><br /></td></tr>
<tr class="separator:ad0794710c612340082e700903ffd1e1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ba2a6e8e774a477513241ebad7d6607"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFATFS__VFS.html#a1ba2a6e8e774a477513241ebad7d6607">mount</a> ()</td></tr>
<tr class="memdesc:a1ba2a6e8e774a477513241ebad7d6607"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mount the FAT file system into VFS. The FAT file system found in the partition is mounted into the VFS.  <a href="#a1ba2a6e8e774a477513241ebad7d6607">More...</a><br /></td></tr>
<tr class="separator:a1ba2a6e8e774a477513241ebad7d6607"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae88702f8fce66d77974571adfe7db5a3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFATFS__VFS.html#ae88702f8fce66d77974571adfe7db5a3">setMaxFiles</a> (int maxFiles)</td></tr>
<tr class="memdesc:ae88702f8fce66d77974571adfe7db5a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the allowable number of concurrently open files.  <a href="#ae88702f8fce66d77974571adfe7db5a3">More...</a><br /></td></tr>
<tr class="separator:ae88702f8fce66d77974571adfe7db5a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5336ad11832bbe13510fed42e0c1322c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFATFS__VFS.html#a5336ad11832bbe13510fed42e0c1322c">unmount</a> ()</td></tr>
<tr class="memdesc:a5336ad11832bbe13510fed42e0c1322c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unmount a previously mounted file system.  <a href="#a5336ad11832bbe13510fed42e0c1322c">More...</a><br /></td></tr>
<tr class="separator:a5336ad11832bbe13510fed42e0c1322c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Provide access to the FAT file system on SPI flash. The <a class="el" href="classFATFS__VFS.html" title="Provide access to the FAT file system on SPI flash. The FATFS_VFS file system needs a partition defin...">FATFS_VFS</a> file system needs a partition definition. This is a map of flash memory that specified an array into which the files should be saved and loaded. A partition is a named entity and the name we choose in the partition definition should be named in the constructor. </p>
<p>A partition configuration file can be described in the <code>make menuconfig</code> settings. For example: </p><div class="fragment"><div class="line">nvs,      data, nvs,     0x9000,  0x6000,</div><div class="line">phy_init, data, phy,     0xf000,  0x1000,</div><div class="line">factory,  app,  factory, 0x10000, 1M,</div><div class="line">storage,  data, fat,     ,        1M,</div></div><!-- fragment --><p>The recommended file name for the partition description is <code>partitions.csv</code></p>
<p>A typical example would be:</p>
<div class="fragment"><div class="line"><a class="code" href="classFATFS__VFS.html">FATFS_VFS</a> *fs = <span class="keyword">new</span> <a class="code" href="classFATFS__VFS.html#ad0794710c612340082e700903ffd1e1b">FATFS_VFS</a>(<span class="stringliteral">&quot;/spiflash&quot;</span>, <span class="stringliteral">&quot;storage&quot;</span>);</div><div class="line">fs-&gt;<a class="code" href="classFATFS__VFS.html#a1ba2a6e8e774a477513241ebad7d6607">mount</a>();</div><div class="line"><span class="comment">// Perform file I/O</span></div><div class="line">fs-&gt;<a class="code" href="classFATFS__VFS.html#a5336ad11832bbe13510fed42e0c1322c">unmount</a>();</div><div class="line"><span class="keyword">delete</span> fs;</div></div><!-- fragment --> </div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad0794710c612340082e700903ffd1e1b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad0794710c612340082e700903ffd1e1b">&#9670;&nbsp;</a></span>FATFS_VFS()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">FATFS_VFS::FATFS_VFS </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>mountPath</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>partitionName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>In ESP32, every file system has a mount point. If a file access is attempted south of that mount point, then the corresponding file system will be used. The <code>mountPath</code> parameter defines the mount point for this instance of the FATFS file system. In order to save the files for subsequent retrieval, the file data has to be written to flash memory. A partition table provides a map or layout of the flash memory by defining named partitions. The <code>partitionName</code> parameter defines the name of the partition used to provide the underlying storage for this instance of the FATFS file system.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">mountPath</td><td>The path in the VFS where the FAT file system should be mounted. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">partitionName</td><td>The name of the partition used to store the FAT file system. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a1ba2a6e8e774a477513241ebad7d6607"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ba2a6e8e774a477513241ebad7d6607">&#9670;&nbsp;</a></span>mount()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FATFS_VFS::mount </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Mount the FAT file system into VFS. The FAT file system found in the partition is mounted into the VFS. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ae88702f8fce66d77974571adfe7db5a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae88702f8fce66d77974571adfe7db5a3">&#9670;&nbsp;</a></span>setMaxFiles()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FATFS_VFS::setMaxFiles </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>maxFiles</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the allowable number of concurrently open files. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">maxFiles</td><td>Number of concurrently open files. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a5336ad11832bbe13510fed42e0c1322c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5336ad11832bbe13510fed42e0c1322c">&#9670;&nbsp;</a></span>unmount()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FATFS_VFS::unmount </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Unmount a previously mounted file system. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="FATFS__VFS_8h_source.html">FATFS_VFS.h</a></li>
<li>FATFS_VFS.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
